/*  @(#) include/imqchl.hpp, imqi, p530, p530-CSD06J 1.27.2.1 02/10/30 11:29:10 */
#ifndef _IMQCHL_HPP_
#define _IMQCHL_HPP_

//  Library:       WebSphere MQ
//  Component:     IMQI (WebSphere MQ C++ MQI)
//  Part:          IMQCHL.HPP
//
//  Description:   "ImqChannel" class declaration
//  <START_COPYRIGHT> 
//  Licensed Materials - Property of IBM 
//                   
//  5724-B41         
//  (C) Copyright IBM Corp. 1994, 2002 All Rights Reserved. 
//                   
//  US Government Users Restricted Rights - Use, duplication or 
//  disclosure restricted by GSA ADP Schedule Contract with 
//  IBM Corp.        
//  <END_COPYRIGHT>  

#include <imqstr.hpp> // ImqString

#define ImqChannel ImqChl

class IMQ_EXPORTCLASS ImqChannel : public ImqError {
  void * opdata ;
  ImqBoolean checkNames ( const size_t, const char * [ ] );
  ImqBoolean checkNames ( const size_t, const ImqString * [ ] );
  ImqBoolean getItems ( const size_t, ImqString * [ ],
                        const char *, const size_t, const size_t );
  ImqBoolean setData ( const MQLONG, const size_t, const char * [ ], MQPTR & );
  ImqBoolean setData ( const MQLONG, const size_t, const ImqString * [ ],
                       MQPTR & );
  ImqBoolean setNames ( const size_t, const char * [ ], MQPTR &, MQPTR & );
  ImqBoolean setNames ( const size_t, const ImqString * [ ], MQPTR &,
                        MQPTR & );
  void varyStorage ( MQLONG &, const size_t, MQPTR &, MQPTR & );
protected :
  friend class ImqMgr ;
  PMQCD MQCD ( ) const ;
public :
  // New methods:
  ImqChannel ( );
  ImqChannel ( const ImqChannel & );
  virtual ~ ImqChannel ( );
  void operator = ( const ImqChannel & );
  MQLONG batchHeartBeat ( ) const;
  ImqString channelName ( ) const ;
  ImqString connectionName ( ) const ;
  MQLONG heartBeatInterval ( ) const ;
  ImqString localAddress() const;
  MQLONG maximumMessageLength ( ) const ;
  ImqString modeName ( ) const ;
  ImqString password ( ) const ;
  size_t receiveExitCount ( ) const ;
  ImqString receiveExitName ( );
  ImqBoolean receiveExitNames ( const size_t, ImqString * [ ] );
  ImqString receiveUserData ( );
  ImqBoolean receiveUserData ( const size_t, ImqString * [ ] );
  ImqString securityExitName ( ) const ;
  ImqString securityUserData ( ) const ;
  size_t sendExitCount ( ) const ;
  ImqString sendExitName ( );
  ImqBoolean sendExitNames ( const size_t, ImqString * [ ] );
  ImqString sendUserData ( );
  ImqBoolean sendUserData ( const size_t, ImqString * [ ] );
  ImqBoolean setBatchHeartBeat ( const MQLONG = 0L );
  ImqBoolean setChannelName ( const char * = 0 );
  ImqBoolean setConnectionName ( const char * = 0 );
  ImqBoolean setHeartBeatInterval ( const MQLONG = 300 );
  ImqBoolean setLocalAddress ( const char * = 0 );
  ImqBoolean setMaximumMessageLength ( const MQLONG = 4194304 );
  ImqBoolean setModeName ( const char * = 0 );
  ImqBoolean setPassword ( const char * = 0 );
  ImqBoolean setReceiveExitName ( const char * = 0 );
  ImqBoolean setReceiveExitNames ( const size_t, const char * [ ] );
  ImqBoolean setReceiveExitNames ( const size_t, const ImqString * [ ] );
  ImqBoolean setReceiveUserData ( const char * = 0 );
  ImqBoolean setReceiveUserData ( const size_t, const char * [ ] );
  ImqBoolean setReceiveUserData ( const size_t, const ImqString * [ ] );
  ImqBoolean setSecurityExitName ( const char * = 0 );
  ImqBoolean setSecurityUserData ( const char * = 0 );
  ImqBoolean setSendExitName ( const char * = 0 );
  ImqBoolean setSendExitNames ( const size_t, const char * [ ] );
  ImqBoolean setSendExitNames ( const size_t, const ImqString * [ ] );
  ImqBoolean setSendUserData ( const char * = 0 );
  ImqBoolean setSendUserData ( const size_t, const char * [ ] );
  ImqBoolean setSendUserData ( const size_t, const ImqString * [ ] );
  ImqBoolean setSslCipherSpecification ( const char * = 0 );
  ImqBoolean setSslClientAuthentication ( const MQLONG = MQSCA_REQUIRED );
  ImqBoolean setSslPeerName ( const char * = 0 );
  ImqBoolean setTransactionProgramName ( const char * = 0 );
  ImqBoolean setTransportType ( const MQLONG = MQXPT_LU62 );
  ImqBoolean setUserId ( const char * = 0 );
  ImqString sslCipherSpecification ( ) const ;
  MQLONG    sslClientAuthentication ( ) const ;
  ImqString sslPeerName ( ) const ;
  ImqString transactionProgramName ( ) const ;
  MQLONG transportType ( ) const ;
  ImqString userId ( ) const ;
} ;

#endif


